#ifndef __ASSEMBLER__

#ifndef __PIC32_C_H__
#define __PIC32_C_H__

#include <stdint.h>
#include "mips.h"
#include "pic32.h"

/* Access. */

#define REG(mem)		*((volatile uint32_t *) (mem))

/* Bit clearing, setting and inverting. */

#define CLR_REG(mem, val)	(REG(mem + CLR) = val)
#define SET_REG(mem, val)	(REG(mem + SET) = val)
#define INV_REG(mem, val)	(REG(mem + INV) = val)

/* Address translation. */

#define PHYSICAL(addr)		(((uint32_t) addr) - KSEG0_BASE)
#define HW_PHYSICAL(addr)	(((uint32_t) addr) - KSEG1_BASE)

/* Register collection access. */

#define DMA_REG(channel, reg)	(DCHBASE + reg + (channel - DCHMIN) * DCHSTEP)
#define UART_REG(channel, reg)	(UARTBASE + reg + (channel - UARTMIN) * UARTSTEP)

#endif /* __PIC32_C_H__ */

#endif /* __ASSEMBLER__ */
